.nolist			; Hit F6 to assemble and run this program
include \masm32\include\masm32rt.inc

WinMain	PROTO:DWORD,:DWORD,:DWORD,:DWORD

sm	equ invoke SendMessage, ; for faster typing ;-)
IdMenuNew	equ 1000	; ID menu item New
IdMenuSave	equ 1001	; ID menu item Save
IdMenuCopy	equ 1100
IdEdit	equ 2000
IdButton1	equ 2001
IdButton2	equ 2002
IdStatic	equ 2003
IdEscape	equ VK_ESCAPE
AppX	equ 100
AppY	equ 100
AppWidth	equ 300
AppHeight	equ 200
ButtonWidth	equ 72
ButtonHeight	equ 24

.data
ClassAppWin	db "MyClass", 0
ClassButton	db "button", 0
ClassEdit	db "edit", 0
ClassStatic	db "static", 0
txButton1	db "PushMe", 0
txButton2	db "Say Hi", 0
txStatic	db "Welcome to", 13, 10	; no 0 - text continues with AppName ;-)
AppName	db "Tiny Win App", 0
MyAccels	ACCEL <FCONTROL or FVIRTKEY, VK_S, IdMenuSave>
LastAccel	ACCEL <FVIRTKEY, VK_ESCAPE, IdEscape>

.data?
ClvEsp	dd ?
SayHiFlag	dd ?
hInstance	HINSTANCE ?
CommandLine	LPSTR ?
hButton1	HWND ?
hButton2	HWND ?
hStatic	HWND ?
hEdit	HWND ?
hMenu	HWND ?
hLib	HANDLE ?
hWin	HANDLE ?
hM1	HWND ?
hM2	HWND ?
hButFnt	HWND ?
hAccT	HWND ?
buffer	db 512 dup(?)

.code
start:
	invoke GetModuleHandle, NULL
	mov hInstance, eax
	invoke GetCommandLine
	invoke WinMain, hInstance, NULL, CommandLine, SW_SHOWDEFAULT
	MsgBox 0, "Bye", "Hi", MB_OK
	invoke ExitProcess, 0

WinMain proc hInst:HINSTANCE, hPrevInst:HINSTANCE, CmdLine:LPSTR, CmdShow:DWORD
LOCAL wc:WNDCLASSEX
LOCAL msg:MSG
LOCAL hwnd:HWND
	call ClearLocVars	; set all local variables to zero
	mov wc.cbSize, SIZEOF WNDCLASSEX
	mov wc.style, CS_HREDRAW or CS_VREDRAW
	mov wc.lpfnWndProc, offset WndProc
;	 mov wc.cbClsExtra, NULL
;	 mov wc.cbWndExtra, NULL
	push hInst
	pop wc.hInstance
	mov wc.hbrBackground, COLOR_BTNFACE+1
	mov wc.lpszClassName, offset ClassAppWin
	invoke LoadIcon, 0, IDI_APPLICATION
	mov wc.hIcon, eax
	mov wc.hIconSm, eax
	invoke LoadCursor, NULL, IDC_ARROW
	mov wc.hCursor, eax
	invoke RegisterClassEx, addr wc
	invoke CreateWindowEx, WS_EX_TOPMOST or WS_EX_TOOLWINDOW,
		addr ClassAppWin, addr AppName,
		WS_OVERLAPPEDWINDOW or WS_CLIPCHILDREN or WS_VISIBLE,
		AppX, AppY, AppWidth, AppHeight,
		NULL, NULL, hInst, NULL
	mov hwnd, eax
	.Repeat
		invoke GetMessage, addr msg, NULL, 0, 0
		.break .if eax==0
		invoke TranslateAccelerator, hwnd, hAccT, addr msg
		.if eax==0	; not an accelerator
			invoke TranslateMessage, addr msg
			invoke DispatchMessage, addr msg
		.endif
	.Until 0
	mov eax, msg.wParam
	ret
WinMain endp

WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
LOCAL rc:RECT, ptrNull:DWORD, LocBuf[1000]:BYTE
	SWITCH uMsg
	CASE WM_CLOSE
;		 MsgBox 0, "Close", "Hi", MB_OK
		invoke DestroyWindow, hWnd	; will destroy all its children, too
		invoke FreeLibrary, hLib			; get rid of RichEd20.dll
		invoke DestroyAcceleratorTable, hAccT

	CASE WM_DESTROY
		invoke PostQuitMessage, NULL

	CASE WM_CREATE
		; -------------------- create keyboard shortcuts -------------------- 
	UrlTest = 1
	if UrlTest eq 0
		mov eax, 1+(dword ptr LastAccel-dword ptr MyAccels)/(SIZEOF ACCEL)
		invoke CreateAcceleratorTable, addr MyAccels, eax	; eax needed because of a [url=http://www.masm32.com/board/index.php?topic=10435.msg76444#msg76444]MASM Version 9.0 bug[/url]

		mov hAccT, eax
		; -------------------- create menus and sub-menus -------------------- 
		mov hMenu, rv(CreateMenu)				; create the main menu
		mov hM1, rv(CreateMenu)				; plus two
		mov hM2, rv(CreateMenu)				; sub menus
		invoke AppendMenu,hMenu, MF_POPUP, hM1,chr$("&File")
		invoke AppendMenu, hM1, MF_STRING, IdMenuNew, chr$("&New",9,"Ctrl+N")
		invoke AppendMenu, hM1, MF_STRING, IdMenuSave, chr$("&Save",9,"Ctrl+S")
		invoke AppendMenu,hMenu, MF_POPUP, hM2,chr$("&Edit")
		invoke AppendMenu, hM2, MF_STRING, IdMenuCopy, chr$("&Copy",9,"Ctrl+C")
		invoke SetMenu, hWnd, hMenu			; attach menu to main window
	endif
		; -------------------- create controls: buttons, edit window, static ---------- 
		invoke GetStockObject, ANSI_VAR_FONT	; get a cute little font for the controls
		mov hButFnt, eax
		invoke SetLastError, 0
		invoke LoadLibrary, chr$("RichEd20.dll")
		.if eax==0
			push edi
			lea edi, LocBuf
			invoke GetLastError
			invoke FormatMessage, FORMAT_MESSAGE_FROM_SYSTEM, 0, eax, 0, edi, 1000, 0
			invoke MessageBox, 0, edi, chr$("Could not load RichEd20.dll"), MB_OK
			pop edi
			exit
		.endif
		mov hLib, eax

	if UrlTest
		MyStyle = WS_EX_TRANSPARENT
		invoke CreateWindowEx, MyStyle, chr$("RichEdit20A"), NULL, 
		  WS_CHILD or WS_VISIBLE\
		  or ES_LEFT or ES_AUTOHSCROLL or ES_MULTILINE, 0, 0, 0, 0,
		  hWnd, IdEdit, hInstance, NULL
		.if eax==0
			push edi
			lea edi, LocBuf
			invoke GetLastError
			invoke FormatMessage, FORMAT_MESSAGE_FROM_SYSTEM, 0, eax, 0, edi, 1000, 0
			invoke MessageBox, 0, edi, chr$("Could not load create RichEdit control"), MB_OK
			pop edi
			exit
		.endif
	else
		MyStyle = WS_EX_CLIENTEDGE
		invoke CreateWindowEx, MyStyle, chr$("RichEdit20A"), NULL, 
			WS_CHILD or WS_VISIBLE or WS_BORDER\
			or ES_LEFT or ES_AUTOHSCROLL or ES_MULTILINE, 0, 0, 0, 0,
			hWnd, IdEdit, hInstance, NULL
	endif
		mov hEdit, eax							; we have created a RichEdit control
		sm eax, EM_GETEVENTMASK, 0, 0
		or eax, ENM_LINK or ENM_CHANGE
		sm hEdit, EM_SETEVENTMASK, 0, eax
;		sm hEdit, EM_AUTOURLDETECT, 1, 0
;		sm eax, WM_SETFONT, hButFnt, 1	; you may choose the small font here

	if UrlTest ne 1
		invoke SetFocus, hEdit					; give the focus to the edit window
	endif
		invoke CreateWindowEx, NULL, addr ClassButton, addr txButton1, 
			WS_CHILD or WS_VISIBLE or BS_DEFPUSHBUTTON, 0, 0, 0, 0,
			hWnd, IdButton1, hInstance, NULL
		mov hButton1, eax						; upper button created
		sm eax, WM_SETFONT, hButFnt, 1	; give it the small font
		invoke CreateWindowEx, NULL, addr ClassButton, addr txButton2, 
			WS_CHILD or WS_VISIBLE or BS_DEFPUSHBUTTON, 0, 0, 0, 0,
			hWnd, IdButton2, hInstance, NULL
		mov hButton2, eax						; lower button created
		sm eax, WM_SETFONT, hButFnt, 1	; give it the small font
		mov edx, rc.bottom 					; area below the two buttons
		sub edx, ButtonHeight*2+15				; will be used for a static control
		invoke CreateWindowEx, NULL, addr ClassStatic, addr txStatic,
			WS_CHILD or WS_VISIBLE or ES_LEFT, 0, 0, 0, 0,
			hWnd, IdStatic, hInstance, NULL
		mov hStatic, eax						; static window under buttons created
		sm eax, WM_SETFONT, hButFnt, 1	; give it the small font

	CASE WM_COMMAND					; react here to menus and controls
		if UrlTest
		mov eax, wParam
		shr eax, 16
		.if eax==EN_CHANGE
			.if SayHiFlag
				and SayHiFlag, 0
			.else
				push esi
				lea esi, LocBuf
				sm hEdit, WM_GETTEXT, 1000, esi
				push eax
				lea eax, ptrNull
				mov byte ptr [eax], 0
				sm hEdit, WM_SETTEXT, 0, eax
				invoke ShowWindow, hEdit, SW_HIDE	; InvalidateRect, WM_PAINT etc won't clear the window
				invoke ShowWindow, hEdit, SW_SHOW
				pop eax
				.if eax>5
					mov ecx, eax
					sub ecx, 4
					.Repeat
						mov eax, [esi+ecx]
						and eax, 0ffffffh
						dec ecx
					.Until ecx==0 || eax=="//:"
					.if ecx
						MsgBox 0, esi, chr$("Congrats, a URL!"), MB_OK
					.endif
				.endif
				pop esi
			.endif
		.endif
		endif
		movzx eax, word ptr wParam			; the Ids are in the lowword of wParam
		switch eax
		case IdMenuNew						; feel free to call your own stuff here...
			sm hStatic, WM_SETTEXT, 0, chr$("You clicked New")
		case IdMenuSave
			sm hStatic, WM_SETTEXT, 0,
			chr$("You either clicked Save, or you pressed Control S")
		case IdMenuCopy
			sm hStatic, WM_SETTEXT, 0, chr$("You clicked Copy")
		case IdButton1
			call MyProc		; [url=+0]click here[/url] to jump to this procedure
		case IdButton2
			call SayHi		; [url=+2]click here[/url] to jump to this procedure
			invoke SetTimer, hWnd, 123, 3000, 0
		case IdEdit
			sm hStatic, WM_SETTEXT, 0, chr$("Type some text")
		case IdEscape
;			MsgBox 0, chr$("Sure to exit?"), addr AppName, MB_YESNO
;			.if eax==IDYES
				sm hWnd, WM_CLOSE, 0, 0	; Escape: exit without asking!
;			.endif
		default
			; MsgBox 0, str$(eax), addr AppName, MB_OK
		endsw
		
	CASE WM_TIMER
		invoke KillTimer, hWnd, 123
		invoke ShowWindow, hEdit, SW_HIDE
		sm hEdit, WM_SETTEXT, 0, chr$(0)
		invoke ShowWindow, hEdit, SW_SHOW

	CASE WM_SIZE			; resize controls
		invoke GetClientRect, hWnd, addr rc
		push esi
		push ebx
		mov esi, rc.right
		sub esi, ButtonWidth	; editbox = window width minus button width
		mov ebx, rc.bottom
		sub ebx, 6
		invoke MoveWindow, hEdit, 3, 3, esi, ebx, 1
		add esi, 5				; buttons 5 pixels right of editbox
		mov ebx, rc.right
		sub ebx, esi
		sub ebx, 3
		invoke MoveWindow, hButton1, esi, 5, ebx, ButtonHeight, 1
		invoke MoveWindow, hButton2, esi, 8+ButtonHeight, ebx, ButtonHeight, 1
		mov edx, rc.bottom
		sub edx, ButtonHeight*2+15
		invoke MoveWindow, hStatic, esi, 11+ButtonHeight*2, ebx, edx, 1
		pop ebx
		pop esi
	ENDSW
	invoke DefWindowProc, hWnd, uMsg, wParam, lParam
	ret
WndProc endp

MyProc proc
	MsgBox 0, chr$("Drag a URL over the area", 13, 10, "to the left of this button"), addr AppName, MB_OK
	ret
MyProc endp		; [url=+1]back to wm_command[/url]

SayHi proc
LOCAL txrg:TEXTRANGE, stx:SETTEXTEX, hFile, dwBytesRead:DWORD
LOCAL LocBuf[8000]:BYTE
	mov stx.flags, ST_DEFAULT or ST_SELECTION or ST_KEEPUNDO
	mov stx.codepage, CP_ACP
	xor eax, eax
	mov txrg.chrg.cpMin, eax		; select first byte
	mov txrg.chrg.cpMax, eax
	invoke SendMessage, hEdit, EM_EXSETSEL, 0, addr txrg
	invoke SendMessage, hEdit, EM_SETTARGETDEVICE, 0, 0
	invoke CreateFile, chr$("demo.rtf"), GENERIC_READ, FILE_SHARE_READ,
	NULL,OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0
	.if eax==INVALID_HANDLE_VALUE
		invoke lstrcpy, addr LocBuf, chr$("Cannot open Demo.rtf")
	.else
		mov hFile, eax
		invoke ReadFile, hFile, addr LocBuf, 8000, ADDR dwBytesRead, 0
		invoke CloseHandle, hFile
		or SayHiFlag, -1
	.endif
	invoke SendMessage, hEdit, EM_SETTEXTEX, addr stx, addr LocBuf
	ret
SayHi endp

; Warning: ClearLocVars does not work with the proc uses edi syntax!
; Workaround: push/pop these registers manually after CLV
ClearLocVars proc		; first instruction after LOCALS - eax will be zero on exit
	pop ClvEsp		; save the return address to this global variable - 
					; now the stack is identical to the calling procedure
	xchg eax, ecx	; save ecx
	mov ecx, ebp	; base page of calling procedure
	sub ecx, esp	; ebp - esp = No. of bytes in locals
	mov esp, ebp	; discard existing locals
	shr ecx, 2		; divide by four
@@:	push 0			; dwords on stack
	loop @B		; until ecx=0
	xchg eax, ecx	; restore ecx, the 0 goes to eax
	push ClvEsp	; restore the return address
	ret
ClearLocVars endp

end start

RichMasm options
OxPT_Icon	Smiley	; see \Masm32\RichMasm\Icons
OxPT_Linker	link	; default is polink (if found), otherwise link.exe
OPT_Res	0
OPT_DebugL	/merge:.text=.data
OPT_Tmp2Asm	1
; delete the x if you prefer \masm32\bin\link.exe
